blob: 02a7d82cfad9c9820e60d4367f56fed08b869dd7 [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with this program; if not, write to the Free Software
Paul Menzela46a7122013-02-23 18:37:27 +010020# Foundation, Inc., 51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA
Stefan Reinauer074d9132009-09-26 16:43:17 +000021#
22
Patrick Georgi8135dba2015-03-17 21:05:20 +010023cd `dirname $0`
24
Patrick Georgi53c388f2015-03-07 09:55:18 +010025CROSSGCC_DATE="March 8th, 2015"
26CROSSGCC_VERSION="1.27"
Stefan Reinauer074d9132009-09-26 16:43:17 +000027
28# default settings
29TARGETDIR=`pwd`/xgcc
30TARGETARCH=i386-elf
31DESTDIR=
32
33# version numbers
Patrick Georgi53c388f2015-03-07 09:55:18 +010034GMP_VERSION=6.0.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070035MPFR_VERSION=3.1.2
Paul Menzele6619422015-02-23 10:33:59 +010036MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000037LIBELF_VERSION=0.8.13
Patrick Georgi53c388f2015-03-07 09:55:18 +010038GCC_VERSION=4.9.2
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070039GCC_AUTOCONF_VERSION=2.69
Patrick Georgi53c388f2015-03-07 09:55:18 +010040BINUTILS_VERSION=2.25
41GDB_VERSION=7.9
42IASL_VERSION=20150204
43PYTHON_VERSION=3.4.3
Idwer Vollering296a0152012-10-26 01:48:04 +020044EXPAT_VERSION=2.1.0
Stefan Reinauer074d9132009-09-26 16:43:17 +000045
46# archive locations
Patrick Georgi53c388f2015-03-07 09:55:18 +010047GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}a.tar.bz2"
Patrick Georgi6e61ad32012-05-12 23:19:30 +020048MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.bz2"
Idwer Vollering7962fc72012-10-25 02:14:09 +020049MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000050LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020051GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070052BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010053GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
54IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix-${IASL_VERSION}.tar.gz"
55PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010056EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.gz"
Stefan Reinauer074d9132009-09-26 16:43:17 +000057
58GMP_DIR="gmp-${GMP_VERSION}"
59MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000060MPC_DIR="mpc-${MPC_VERSION}"
61LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000062GCC_DIR="gcc-${GCC_VERSION}"
63BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
64GDB_DIR="gdb-${GDB_VERSION}"
Marc Jones2aac3f62011-08-08 16:07:50 -060065IASL_DIR="acpica-unix-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010066PYTHON_DIR="Python-${PYTHON_VERSION}"
67EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000068
Patrick Georgi6321f522015-02-27 23:36:26 +010069unset MAKELEVEL MAKEFLAGS
70
Stefan Reinauer074d9132009-09-26 16:43:17 +000071SAVETEMPS=0
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010072SKIPGDB=1
73SKIPPYTHON=1
Stefan Reinauer074d9132009-09-26 16:43:17 +000074
Patrick Georgi1861ff72011-10-31 12:15:55 +010075red='\033[0;31m'
76RED='\033[1;31m'
77green='\033[0;32m'
78GREEN='\033[1;32m'
79blue='\033[0;34m'
80BLUE='\033[1;34m'
81cyan='\033[0;36m'
82CYAN='\033[1;36m'
83NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +000084
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070085UNAME=`uname`
86
Patrick Georgi198d23c2012-12-08 08:02:44 +010087normalize_dirs()
88{
89 mkdir -p $DESTDIR$TARGETDIR/lib
90 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
91 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
92 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
93
94 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
95 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
96}
97
Patrick Georgib7062882015-02-24 10:52:14 +010098searchtool()
Stefan Reinauer074d9132009-09-26 16:43:17 +000099{
100 # $1 short name
Patrick Georgib7062882015-02-24 10:52:14 +0100101 # $2 search string
102 # $3 soft fail if set
103 # result: file name of that tool on stdout
104 # or no output if nothing suitable was found
105 search=GNU
106 if [ -n "$2" ]; then
107 search="$2"
108 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000109 for i in "$1" "g$1" "gnu$1"; do
110 if test -x "`which $i 2>/dev/null`"; then
Alexander Couzensd268ab32015-04-13 17:15:12 +0200111 if test `cat /dev/null | $i --version 2>&1 |grep -c "$search"` \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100112 -gt 0; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000113 echo $i
114 return
115 fi
116 fi
117 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800118 # A workaround for OSX 10.9 and some BSDs, whose nongnu
119 # patch and tar also work.
Patrick Georgi7cb26b42015-04-28 21:29:22 +0200120 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" -o $UNAME = "OpenBSD" ]; then
Patrick Georgib7062882015-02-24 10:52:14 +0100121 if [ "$1" = "patch" -o "$1" = "tar" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800122 if test -x "`which $1 2>/dev/null`"; then
123 echo $1
124 return
125 fi
126 fi
127 fi
zbao939dc842015-04-30 04:44:07 +0800128 if [ "`echo $1 | cut -b -3`" = "sha" ]; then
129 if [ $UNAME = "FreeBSD" ]; then
130 if test -x "`which sha1 2>/dev/null`"; then
131 echo sha1
132 return
133 fi
134 fi
135 if [ $UNAME = "NetBSD" ]; then
136 if test -x "`which cksum 2>/dev/null`"; then
137 echo cksum -a `echo $1 | sed -e 's,sum,,'`
138 return
139 fi
140 fi
141 if [ $UNAME = "Darwin" ]; then
142 if test -x "`which openssl 2>/dev/null`"; then
143 echo openssl `echo $1 | sed -e 's,sum,,'`
144 return
145 fi
146 fi
147 fi
Patrick Georgiae5ab602015-04-29 23:30:15 +0200148 printf "${RED}ERROR:${red} Missing tool: Please install $1 (eg using your OS packaging system)${NC}\n" >&2
Patrick Georgib7062882015-02-24 10:52:14 +0100149 [ -z "$3" ] && exit 1
150 false
Stefan Reinauer074d9132009-09-26 16:43:17 +0000151}
152
Patrick Georgib7062882015-02-24 10:52:14 +0100153TAR=`searchtool tar` || exit $?
154PATCH=`searchtool patch` || exit $?
155MAKE=`searchtool make` || exit $?
Stefan Reinauer074d9132009-09-26 16:43:17 +0000156
Patrick Georgib7062882015-02-24 10:52:14 +0100157searchtool m4 > /dev/null
158searchtool bison > /dev/null
159searchtool flex flex > /dev/null
160searchtool g++ "Free Software Foundation" nofail > /dev/null || \
Patrick Georgi915c4fc2015-03-09 13:58:23 +0100161searchtool clang "clang version" > /dev/null
162searchtool wget > /dev/null
163searchtool bzip2 "bzip2," > /dev/null
Patrick Georgi5fb2b5c2012-05-12 23:25:23 +0200164
Patrick Georgi74c06422015-03-25 18:40:13 +0100165wait_for_build() {
166 # $1: directory in which log file and failure marker are stored
167 cat > "$1/crossgcc-build.log"
168 test -r "$1/.failed" && printf "${RED}failed${NC}. Check $1/crossgcc-build.log.\n" || \
169 printf "${green}ok${NC}\n"
170 test -r "$1/.failed" && exit 1
171 true
172}
173
zbao939dc842015-04-30 04:44:07 +0800174SHA1SUM=`searchtool sha1sum`
175SHA512SUM=`searchtool sha512sum`
176CHECKSUM=$SHA1SUM
177
Stefan Reinauer074d9132009-09-26 16:43:17 +0000178cleanup()
179{
180 printf "Cleaning up temporary files... "
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200181 rm -rf ${BUILDDIRPREFIX}-* combined gcc-* gmp-* mpfr-* mpc-* libelf-* binutils-*
Patrick Georgi969cd932012-12-07 13:13:53 +0100182 rm -rf gdb-* acpica-* python-* expat-*
Stefan Reinauer074d9132009-09-26 16:43:17 +0000183 printf "${green}ok${NC}\n"
184}
185
186myhelp()
187{
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100188 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000189 printf " $0 [-V|--version]\n"
190 printf " $0 [-h|--help]\n\n"
191
192 printf "Options:\n"
193 printf " [-V|--version] print version number and exit\n"
194 printf " [-h|--help] print this help and exit\n"
195 printf " [-c|--clean] remove temporary files before build\n"
196 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100197 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000198 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000199 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
200 printf " (defaults to $TARGETARCH)\n"
201 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
202 printf " (defaults to $TARGETDIR)\n\n"
203 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100204 printf " (for RPM builds, default unset)\n"
205 printf " [-G|--gdb] build GNU debugger\n"
206 printf " [-S|--scripting] build scripting support for GDB\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000207}
208
209myversion()
210{
211 # version tag is always printed, so just print the license here
212
213 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000214Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600215Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000216
217This program is free software; you can redistribute it and/or modify
218it under the terms of the GNU General Public License as published by
219the Free Software Foundation; version 2 of the License.
220
221This program is distributed in the hope that it will be useful,
222but WITHOUT ANY WARRANTY; without even the implied warranty of
223MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
224GNU General Public License for more details.
225
226EOF
227}
228
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700229printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000230
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000231# Look if we have getopt. If not, build it.
232export PATH=$PATH:.
233getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
234
Stefan Reinauer074d9132009-09-26 16:43:17 +0000235# parse parameters.. try to find out whether we're running GNU getopt
Peter Stuge09377b72011-08-21 06:24:55 +0200236getoptbrand="`getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,'`"
237if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000238 # Detected GNU getopt that supports long options.
Patrick Georgic1a75b12011-11-04 21:37:14 +0100239 args=`getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb,ccache Vhcd:p:j:D:tGy -- "$@"`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000240 eval set "$args"
241else
242 # Detected non-GNU getopt
Patrick Georgic1a75b12011-11-04 21:37:14 +0100243 args=`getopt Vhcd:p:j:D:tGy $*`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000244 set -- $args
245fi
246
247if [ $? != 0 ]; then
248 myhelp
249 exit 1
250fi
251
252while true ; do
253 case "$1" in
254 -V|--version) shift; myversion; exit 0;;
255 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100256 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000257 -t|--savetemps) shift; SAVETEMPS=1;;
258 -d|--directory) shift; TARGETDIR="$1"; shift;;
259 -p|--platform) shift; TARGETARCH="$1"; shift;;
260 -D|--destdir) shift; DESTDIR="$1"; shift;;
Patrick Georgi73166c72010-04-14 20:42:42 +0000261 -j|--jobs) shift; JOBS="-j $1"; shift;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100262 -G|--gdb) shift; SKIPGDB=0;;
263 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100264 -y|--ccache) shift; USECCACHE=1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200265 --) shift; break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000266 -*) printf "Invalid option\n\n"; myhelp; exit 1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200267 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000268 esac
269done
270
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700271case "$TARGETARCH" in
Stefan Reinauer24f9cb92015-03-13 22:50:22 +0100272 x86_64-elf) ;;
273 x86_64*) TARGETARCH=x86_64-elf;;
David Hubbard5b0420a2013-05-28 16:33:15 -0600274 i386-elf) ;;
275 i386-mingw32) ;;
Patrick Georgi9b7efa52015-03-08 09:20:36 +0100276 mipsel-elf) ;;
Patrick Georgif0bbc952015-03-07 10:57:25 +0100277 riscv-elf) ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700278 i386*) TARGETARCH=i386-elf;;
Patrick Georgic8883262013-09-19 10:57:58 +0200279 arm*) TARGETARCH=armv7-a-eabi;;
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700280 aarch64*) TARGETARCH=aarch64-elf;;
281 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700282esac
283
284echo "Target arch is now $TARGETARCH"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200285BUILDDIRPREFIX=build-${TARGETARCH}
286
Patrick Georgi44af57a2013-12-19 22:06:22 +0100287if [ "$clean" = "1" ]; then
288 cleanup
289fi
290
Peter Stugeceacd772011-06-09 04:54:16 +0200291GDB_PACKAGE="GDB"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100292PYTHON_PACKAGE="PYTHON"
293EXPAT_PACKAGE="EXPAT"
Peter Stugeceacd772011-06-09 04:54:16 +0200294if [ $SKIPGDB -eq 1 ]; then
295 printf "Will skip GDB ... ${green}ok${NC}\n"
Peter Stuge0e8ee812011-08-28 11:04:23 +0200296 GDB_ARCHIVE=""
Peter Stugeceacd772011-06-09 04:54:16 +0200297 GDB_PACKAGE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100298 if [ $SKIPPYTHON -eq 0 ]; then
299 printf "Python scripting needs GDB ... disabling ... ${green}ok${NC}\n"
300 SKIPPYTHON=1
301 fi
302fi
303if [ $SKIPPYTHON -eq 1 ]; then
Jonathan A. Kollasch2d7ab4c2011-11-07 13:05:18 -0600304 PYTHON_ARCHIVE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100305 PYTHON_PACKAGE=""
Jonathan A. Kollasch2d7ab4c2011-11-07 13:05:18 -0600306 EXPAT_ARCHIVE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100307 EXPAT_PACKAGE=""
Peter Stugeceacd772011-06-09 04:54:16 +0200308fi
309
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700310# coreboot does not like the GOLD linker
311# USE_GOLD="--enable-gold"
312USE_GOLD=""
313GCC_OPTIONS="--enable-lto"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000314
Stefan Reinauer074d9132009-09-26 16:43:17 +0000315printf "Downloading tar balls ... \n"
316mkdir -p tarballs
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100317for ARCHIVE in $GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE \
Patrick Georgi969cd932012-12-07 13:13:53 +0100318 $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100319 $IASL_ARCHIVE $PYTHON_ARCHIVE $EXPAT_ARCHIVE; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000320 FILE=`basename $ARCHIVE`
321 printf " * $FILE "
zbao939dc842015-04-30 04:44:07 +0800322
323 ##create the sum
324 #test -f sum/$FILE.cksum || (
325 # $CHECKSUM tarballs/$FILE > sum/$FILE.cksum
326 # continue
327 #)
328
329 test -f tarballs/$FILE && \
330 (test -z "$CHECKSUM" || \
331 test "`cat sum/$FILE.cksum 2>/dev/null | sed -e 's,.*\([0-9a-f]\{40\}\).*,\1,'`" = "`$CHECKSUM tarballs/$FILE 2>/dev/null | sed -e 's,.*\([0-9a-f]\{40\}\).*,\1,'`" ) && \
332 printf "(cached)" || (
Stefan Reinauer074d9132009-09-26 16:43:17 +0000333 printf "(downloading)"
zbao939dc842015-04-30 04:44:07 +0800334 rm -f tarballs/$FILE
Stefan Reinauer074d9132009-09-26 16:43:17 +0000335 cd tarballs
Patrick Georgi6e61ad32012-05-12 23:19:30 +0200336 wget --no-check-certificate -q $ARCHIVE
zbao939dc842015-04-30 04:44:07 +0800337 cd ..
338 test ! -f sum/$FILE.cksum && test -f tarballs/$FILE && \
339 (test -z "$CHECKSUM" || $CHECKSUM tarballs/$FILE > sum/$FILE.cksum ) && \
340 printf "(checksum created. ${RED}Note. Please upload sum/$FILE.cksum if the corresponding archive is upgraded.${NC})"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000341 )
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100342 test -f tarballs/$FILE || \
Zheng Bao5b209c02012-09-20 16:09:51 +0800343 printf "\n${RED}Failed to download $FILE.${NC}\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000344 test -f tarballs/$FILE || exit 1
345 printf "\n"
346done
347printf "Downloaded tar balls ... "
348printf "${green}ok${NC}\n"
349
350printf "Unpacking and patching ... \n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100351for PACKAGE in GMP MPFR MPC LIBELF GCC BINUTILS $PYTHON_PACKAGE \
Patrick Georgi969cd932012-12-07 13:13:53 +0100352 $EXPAT_PACKAGE $GDB_PACKAGE IASL; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000353 archive=$PACKAGE"_ARCHIVE"
Peter Stuge09377b72011-08-21 06:24:55 +0200354 archive="`eval echo '$'$archive`"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000355 dir=$PACKAGE"_DIR"
Peter Stuge09377b72011-08-21 06:24:55 +0200356 dir="`eval echo '$'${dir}`"
Zheng Baof95bb2d2013-12-13 12:30:46 +0800357 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauer074d9132009-09-26 16:43:17 +0000358 printf " * `basename $archive`\n"
359 FLAGS=zxf
Peter Stuge09377b72011-08-21 06:24:55 +0200360 suffix=`echo $archive | sed 's,.*\.,,'`
361 test "$suffix" = "gz" && FLAGS=zxf
362 test "$suffix" = "bz2" && FLAGS=jxf
Patrick Georgi53c388f2015-03-07 09:55:18 +0100363 test "$suffix" = "xz" && FLAGS="--xz -xf"
Peter Stuge09377b72011-08-21 06:24:55 +0200364 test "$suffix" = "lzma" && FLAGS="--lzma -xf"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000365 $TAR $FLAGS tarballs/`basename $archive`
Peter Stuge09377b72011-08-21 06:24:55 +0200366 for patch in patches/${dir}_*.patch; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000367 test -r $patch || continue
368 printf " o `basename $patch`\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100369 $PATCH -s -N -p0 < `echo $patch` || \
Zheng Bao5b209c02012-09-20 16:09:51 +0800370 printf "\n${RED}Failed $patch.${NC}\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000371 done
Zheng Bao691b313c2013-12-09 14:09:07 +0800372 touch ${dir}/.unpack_success
Stefan Reinauer074d9132009-09-26 16:43:17 +0000373 )
374done
375printf "Unpacked and patched ... "
376printf "${green}ok${NC}\n"
377
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700378CC=cc
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700379if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000380 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
381
382 # generally the OS X compiler can create x64 binaries.
383 # Per default it generated i386 binaries in 10.5 and x64
384 # binaries in 10.6 (even if the kernel is 32bit)
385 # For some weird reason, 10.5 autodetects an ABI=64 though
386 # so we're setting the ABI explicitly here.
Zheng Bao04ceed62012-10-23 19:41:25 +0800387 if [ `sysctl -n hw.optional.x86_64 2>/dev/null` -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000388 OPTIONS="ABI=64"
389 else
390 OPTIONS="ABI=32"
391 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700392
Stefan Reinauer4266b922012-12-05 16:18:32 -0800393 # In Xcode 4.5.2 the default compiler is clang.
394 # However, this compiler fails to compile gcc 4.7.x. As a
395 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700396 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800397 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700398 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000399fi
400
Patrick Georgic1a75b12011-11-04 21:37:14 +0100401if [ "$USECCACHE" = 1 ]; then
402 CC="ccache $CC"
403fi
404
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200405mkdir -p ${BUILDDIRPREFIX}-gmp ${BUILDDIRPREFIX}-mpfr ${BUILDDIRPREFIX}-mpc ${BUILDDIRPREFIX}-libelf ${BUILDDIRPREFIX}-binutils \
406 ${BUILDDIRPREFIX}-gcc ${BUILDDIRPREFIX}-python ${BUILDDIRPREFIX}-expat
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100407
408mkdir -p $DESTDIR$TARGETDIR/bin
409export PATH=$DESTDIR$TARGETDIR/bin:$PATH
410
Peter Stugeceacd772011-06-09 04:54:16 +0200411if [ $SKIPGDB -eq 0 ]; then
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200412 mkdir -p ${BUILDDIRPREFIX}-gdb
Peter Stugeceacd772011-06-09 04:54:16 +0200413fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200414if [ -f ${BUILDDIRPREFIX}-gmp/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000415 printf "Skipping GMP as it is already built\n"
416else
417printf "Building GMP ${GMP_VERSION} ... "
418(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200419 cd ${BUILDDIRPREFIX}-gmp
Stefan Reinauer074d9132009-09-26 16:43:17 +0000420 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100421 CC="$CC" ../${GMP_DIR}/configure --disable-shared --prefix=$TARGETDIR $OPTIONS \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000422 || touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000423 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000424 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100425
426 normalize_dirs
427
Stefan Reinauer074d9132009-09-26 16:43:17 +0000428 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100429) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-gmp" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000430fi
431
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700432# Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
433# as GCC 4.6.x fails if it's there.
434HOSTCFLAGS=`grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
435 sed s,-pedantic,,`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000436
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200437if [ -f ${BUILDDIRPREFIX}-mpfr/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000438 printf "Skipping MPFR as it is already built\n"
439else
440printf "Building MPFR ${MPFR_VERSION} ... "
441(
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700442 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200443 cd ${BUILDDIRPREFIX}-mpfr
Stefan Reinauer074d9132009-09-26 16:43:17 +0000444 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100445 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000446 --infodir=$TARGETDIR/info \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100447 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
448 touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000449 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000450 $MAKE install DESTDIR=$DESTDIR || touch .failed
451
Patrick Georgi198d23c2012-12-08 08:02:44 +0100452 normalize_dirs
453
Stefan Reinauer074d9132009-09-26 16:43:17 +0000454 # work around build problem of libgmp.la
455 if [ "$DESTDIR" != "" ]; then
456 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
457 fi
458
459 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100460) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-mpfr" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000461fi
462
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200463if [ -f ${BUILDDIRPREFIX}-mpc/.success ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000464 printf "Skipping MPC as it is already built\n"
465else
466printf "Building MPC ${MPC_VERSION} ... "
467(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200468 cd ${BUILDDIRPREFIX}-mpc
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000469 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100470 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000471 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100472 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
473 touch .failed
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000474 $MAKE $JOBS || touch .failed
475 $MAKE install DESTDIR=$DESTDIR || touch .failed
476
Patrick Georgi198d23c2012-12-08 08:02:44 +0100477 normalize_dirs
478
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000479 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100480) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-mpc" || exit 1
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000481fi
482
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200483if [ -f ${BUILDDIRPREFIX}-libelf/.success ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000484 printf "Skipping libelf as it is already built\n"
485else
486printf "Building libelf ${LIBELF_VERSION} ... "
487(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200488 cd ${BUILDDIRPREFIX}-libelf
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000489 rm -f .failed
490 echo "$HOSTCFLAGS"
Patrick Georgi643c9e82011-11-04 21:30:49 +0100491 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100492 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000493 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
494 $MAKE $JOBS || touch .failed
Scott Duplichan4270a972014-12-12 20:21:40 -0600495 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000496
Patrick Georgi198d23c2012-12-08 08:02:44 +0100497 normalize_dirs
498
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000499 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100500) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-libelf" || exit 1
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000501fi
502
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200503if [ -f ${BUILDDIRPREFIX}-binutils/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000504 printf "Skipping binutils as it is already built\n"
505else
506printf "Building binutils ${BINUTILS_VERSION} ... "
507(
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700508 # What a pain: binutils don't come with configure
509 # script anymore. Create it:
510 cd binutils-${BINUTILS_VERSION}/
511 autoconf
512 cd ..
513 # Now build binutils
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200514 cd ${BUILDDIRPREFIX}-binutils
Stefan Reinauer074d9132009-09-26 16:43:17 +0000515 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100516 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100517 --target=${TARGETARCH} --disable-werror --disable-nls \
518 $USE_GOLD CFLAGS="$HOSTCFLAGS" || touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000519 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000520 $MAKE install DESTDIR=$DESTDIR || touch .failed
521 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100522) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-binutils" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000523fi
524
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200525if [ -f ${BUILDDIRPREFIX}-gcc/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000526 printf "Skipping GCC as it is already built\n"
527else
528printf "Building GCC ${GCC_VERSION} ... "
529(
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700530 # Even worse than binutils: GCC does not come with configure
531 # script anymore, but also enforces an obsolete autoconf version
532 # to create it. This is a poster child of how autotools help make
533 # software portable.
534 cd gcc-${GCC_VERSION}
535 sed '/dnl Ensure exactly this Autoconf version is used/d' \
536 config/override.m4 > config/override.m4.new
537 autoconf_version=`autoconf -V | grep "autoconf" | tr ' ' '\n' | tail -1`
538 sed "s/${GCC_AUTOCONF_VERSION}/${autoconf_version}/g" \
539 config/override.m4.new > config/override.m4
540 autoconf
541 cd ..
542 # Now, finally, we can build gcc:
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200543 cd ${BUILDDIRPREFIX}-gcc
Stefan Reinauer074d9132009-09-26 16:43:17 +0000544 rm -f .failed
545 # GCC does not honour HOSTCFLAGS at all. CFLAGS are used for
546 # both target and host object files. This is pretty misdesigned.
547 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
548 # but it does not seem to work properly. At least the host library
549 # libiberty is not compiled with CFLAGS_FOR_BUILD.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700550 CC="$CC" CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" \
551 CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000552 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
Stefan Reinauer6ade1612010-01-16 16:44:20 +0000553 --target=${TARGETARCH} --disable-werror --disable-shared \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000554 --disable-libssp --disable-bootstrap --disable-nls \
Patrick Georgi969cd932012-12-07 13:13:53 +0100555 --disable-libquadmath --without-headers \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000556 $GCC_OPTIONS --enable-languages="c" $USE_GOLD \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000557 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000558 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
559 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000560 || touch .failed
Patrick Georgi969cd932012-12-07 13:13:53 +0100561 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
562 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
563
564 if [ "`echo $TARGETARCH | grep -c -- -mingw32`" -eq 0 ]; then
565 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
566 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
567 fi
568
Stefan Reinauer074d9132009-09-26 16:43:17 +0000569 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100570) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-gcc" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000571fi
572
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200573if [ -f ${BUILDDIRPREFIX}-expat/.success ]; then
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100574 printf "Skipping Expat as it is already built\n"
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100575elif [ $SKIPPYTHON -eq 1 ]; then
576 printf "Skipping Expat (Python scripting not enabled)\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100577else
578printf "Building Expat ${EXPAT_VERSION} ... "
579(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200580 cd ${BUILDDIRPREFIX}-expat
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100581 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100582 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100583 --prefix=$TARGETDIR --target=${TARGETARCH} || touch .failed
584 $MAKE || touch .failed
585 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100586
587 normalize_dirs
588
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100589 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100590) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-expat" || exit 1
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100591fi
592
593
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200594if [ -f ${BUILDDIRPREFIX}-python/.success ]; then
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100595 printf "Skipping Python as it is already built\n"
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100596elif [ $SKIPPYTHON -eq 1 ]; then
597 printf "Skipping Python (Python scripting not enabled)\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100598else
599printf "Building Python ${PYTHON_VERSION} ... "
600(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200601 cd ${BUILDDIRPREFIX}-python
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100602 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100603 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100604 --target=${TARGETARCH} || touch .failed
605 $MAKE $JOBS || touch .failed
606 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100607
608 normalize_dirs
609
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100610 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100611) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-python" || exit 1
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100612fi
613
614
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200615if [ -f ${BUILDDIRPREFIX}-gdb/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000616 printf "Skipping GDB as it is already built\n"
Peter Stugeceacd772011-06-09 04:54:16 +0200617elif [ $SKIPGDB -eq 1 ]; then
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100618 printf "Skipping GDB (GDB support not enabled)\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000619else
620printf "Building GDB ${GDB_VERSION} ... "
621(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200622 cd ${BUILDDIRPREFIX}-gdb
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100623 export PYTHONHOME=$DESTDIR$TARGETDIR
Stefan Reinauer074d9132009-09-26 16:43:17 +0000624 rm -f .failed
Idwer Vollering1b7c9592015-04-09 15:34:07 +0200625 if [ $(uname) != "FreeBSD" -a $(uname) != "NetBSD" ]; then
626 LIBDL="-ldl"
627 fi
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100628 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
Idwer Vollering1b7c9592015-04-09 15:34:07 +0200629 -lpthread $LIBDL -lutil" \
Patrick Georgi643c9e82011-11-04 21:30:49 +0100630 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100631 ../gdb-${GDB_VERSION}/configure --prefix=$TARGETDIR \
632 --target=${TARGETARCH} --disable-werror --disable-nls
Patrick Georgi73166c72010-04-14 20:42:42 +0000633 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000634 $MAKE install DESTDIR=$DESTDIR || touch .failed
635 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100636) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-gdb" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000637fi
638
Patrick Georgi6e61ad32012-05-12 23:19:30 +0200639if [ -f $IASL_DIR/source/compiler/.success ]; then
Marc Jones2aac3f62011-08-08 16:07:50 -0600640 printf "Skipping IASL as it is already built\n"
641else
642printf "Building IASL ${IASL_VERSION} ... "
643(
Patrick Georgi74c06422015-03-25 18:40:13 +0100644 RDIR=$IASL_DIR/source/compiler
Idwer Vollering6b11c8b2012-11-15 21:14:36 +0100645 cd $IASL_DIR/generate/unix
Patrick Georgi74c06422015-03-25 18:40:13 +0100646 rm -f $RDIR/.failed
Marc Jones2aac3f62011-08-08 16:07:50 -0600647 CFLAGS="$HOSTCFLAGS"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700648 HOST="_LINUX"
649 test $UNAME = "Darwin" && HOST="_APPLE"
650 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
651 test $UNAME = "Cygwin" && HOST="_CYGWIN"
Patrick Georgi74c06422015-03-25 18:40:13 +0100652 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2" CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch $RDIR/.failed
653 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch $RDIR/.failed
654 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch $RDIR/.failed
655 if [ ! -f $RDIR/.failed ]; then touch $RDIR/.success; fi
656) 2>&1 | wait_for_build "$IASL_DIR/source/compiler" || exit 1
Marc Jones2aac3f62011-08-08 16:07:50 -0600657fi
658
Patrick Georgi5602f2c2015-03-28 15:48:47 +0100659PROGNAME=`basename "$0"`
660rm -f "$DESTDIR$TARGETDIR/$PROGNAME".commit.*
661cp "$PROGNAME" $DESTDIR$TARGETDIR/"$PROGNAME.commit.`git describe`"
Zheng Bao30b895f2013-02-06 18:04:40 +0800662
Stefan Reinauer074d9132009-09-26 16:43:17 +0000663if [ $SAVETEMPS -eq 0 ]; then
664 printf "Cleaning up... "
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200665 rm -rf ${GMP_DIR} ${BUILDDIRPREFIX}-gmp
666 rm -rf ${MPFR_DIR} ${BUILDDIRPREFIX}-mpfr
667 rm -rf ${MPC_DIR} ${BUILDDIRPREFIX}-mpc
668 rm -rf ${LIBELF_DIR} ${BUILDDIRPREFIX}-libelf
669 rm -rf ${BINUTILS_DIR} ${BUILDDIRPREFIX}-binutils
670 rm -rf ${GCC_DIR} ${BUILDDIRPREFIX}-gcc
671 rm -rf ${GDB_DIR} ${BUILDDIRPREFIX}-gdb
672 rm -rf ${EXPAT_DIR} ${BUILDDIRPREFIX}-expat
673 rm -rf ${PYTHON_DIR} ${BUILDDIRPREFIX}-python
Marc Jones2aac3f62011-08-08 16:07:50 -0600674 rm -rf ${IASL_DIR}
Stefan Reinauer074d9132009-09-26 16:43:17 +0000675 printf "${green}ok${NC}\n"
676else
677 printf "Leaving temporary files around... ${green}ok${NC}\n"
678fi
679
680printf "\n${green}You can now run your $TARGETARCH cross toolchain from $TARGETDIR.${NC}\n"
681
682